/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __GDAM_QUEUE_H_
#define __GDAM_QUEUE_H_


/*
 * A source which is the continuous concatenation of
 * several sources.
 */

typedef struct _GdamQueue GdamQueue;
typedef struct _GdamQueueClass GdamQueueClass;

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include "../gdamsource.h"

GtkType gdam_queue_get_type();
#define GDAM_TYPE_QUEUE			(gdam_queue_get_type ())
#define GDAM_QUEUE(obj)              (GTK_CHECK_CAST ((obj), GDAM_TYPE_QUEUE, GdamQueue))
#define GDAM_QUEUE_CLASS(klass)      (GTK_CHECK_CLASS_CAST ((klass), GDAM_TYPE_QUEUE, GdamQueueClass))
#define GDAM_IS_QUEUE(obj)           (GTK_CHECK_TYPE ((obj), GDAM_TYPE_QUEUE))
#define GDAM_IS_QUEUE_CLASS(klass)   (GTK_CHECK_CLASS_TYPE ((klass), GDAM_TYPE_QUEUE))

struct _GdamQueueClass {
	GdamSourceClass		source_class;
};
struct _GdamQueue {
	GdamSource		source;

	GSList*			first_source;
	GSList*			last_source;

	gboolean		terminates;
};

GdamQueue* gdam_queue_new      ();
void       gdam_queue_enqueue  (GdamQueue*    queue,
                                GdamSource*   source);
void       gdam_queue_dequeue  (GdamQueue*    queue);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
