/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __GDAM_SYNTH_DELAY_LINE_H_
#define __GDAM_SYNTH_DELAY_LINE_H_


typedef struct _GdamSynthDelayLine GdamSynthDelayLine;
typedef struct _GdamSynthDelayLineClass GdamSynthDelayLineClass;

#include "gdamsynthfilter.h"

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

GtkType gdam_synth_delay_line_get_type();
#define GDAM_TYPE_SYNTH_DELAY_LINE			(gdam_synth_delay_line_get_type ())
#define GDAM_SYNTH_DELAY_LINE(obj)              (GTK_CHECK_CAST ((obj), GDAM_TYPE_SYNTH_DELAY_LINE, GdamSynthDelayLine))
#define GDAM_SYNTH_DELAY_LINE_CLASS(klass)      (GTK_CHECK_CLASS_CAST ((klass), GDAM_TYPE_SYNTH_DELAY_LINE, GdamSynthDelayLineClass))
#define GDAM_IS_SYNTH_DELAY_LINE(obj)           (GTK_CHECK_TYPE ((obj), GDAM_TYPE_SYNTH_DELAY_LINE))
#define GDAM_IS_SYNTH_DELAY_LINE_CLASS(klass)   (GTK_CHECK_CLASS_TYPE ((klass), GDAM_TYPE_SYNTH_DELAY_LINE))

struct _GdamSynthDelayLineClass {
	GdamSynthFilterClass		synth_delay_line_class;


};
struct _GdamSynthDelayLine {
	GdamSynthFilter			synth_delay_line;

	/* Circular buffer. */

	int			buffer_length;
	gdouble*		buffer;

	/* Point in buffer where samples comes out of. */
	int			out_point;

	/* Point to write next samples in to. */
	int			in_point;
};

void      gdam_synth_delay_line_set_buffer_length
                               (GdamSynthDelayLine* delay,
                                int                 max_buffer_length);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
